#  Copyright 2007 by George F. Bertsch.  Use is permitted provided any
#  publications cite the code source, N. Sandulescu and G.F. Bertsch,
#  Phy. Rev. C 78 064318 (2008).

import sys

def nset(integer) :
  n=0 
  while integer != 0 :
    n += integer%2
    integer = integer/2
  return n
norb=int(sys.argv[1])
npair=int(sys.argv[2])

def display(integer,f1) :
  bits=[0]*norb
  for k in range(norb) :
    f1.write(' '+str(integer%2))
    bits[k] = integer%2 
    integer = integer/2
  f1.write('\n')
  return bits

def list(n) :
  ll=[]
  for i in range(2**norb) :
    if nset(i) == n :  ll.append(i)
  return ll
def twobody(i,j,ll) :
   int1=ll[i]
   int2=ll[j]
   kp=-1
   km=-1
   for k in range(norb) :
     if int1%2 > int2%2  :
       if kp == -1 :
         kp=k
       else :
         kp=-2  
     if int1%2 < int2%2 :
       if km == -1 :
         km = k
       else :
         km = -2
     int1=int1/2
     int2=int2/2    
   if km >= 0 and kp >= 0 :
     return kp,km
ll=list(npair)
             
f1=open('t.dat','w')
dim=len(ll)
ss=' %i %i %i\n' % (norb,npair,dim)
f1.write(ss)
for k in range(dim) :
  display(ll[k],f1)

def me(ll,f1) :
  count=0
  for i in range(dim) :
    for j in range(i) :
      nonzero = twobody(i,j,ll) 
      if nonzero :
        count += 1
#        print display(ll[i])
#        print display(ll[j])
#        print
        ss='   %i %i %i %i\n' % (i,j,nonzero[0],nonzero[1])
        f1.write(ss)
  return count     
  
print me(ll,f1)
ss='   -1 0 0 0\n'
f1.write(ss)
f1.close()      
